freeslot("sfx_drpdsh", "S_PLAY_DROPDASH", "SPR2_DRPD")
sfxinfo[sfx_drpdsh].caption = "Drop Dash"

local dropskin = "sonic"

addHook("PlayerThink", function(player)
	if player.dropcharging == nil
		player.dropcharging = false
	end
end)


states[S_PLAY_DROPDASH] = {
	sprite = SPR_PLAY,
	frame = SPR2_DRPD,
	tics = 1,
	nextstate = S_PLAY_DROPDASH
}


addHook("JumpSpinSpecial", function(player)
	if (player.mo.skin == dropskin)
	and (player.mo.state == S_PLAY_JUMP)
	and not (player.powers[pw_shield])
	and not (player.playerstate == PST_DEAD)
		player.dropcharging = true
		S_StartSound(player.mo, sfx_drpdsh)
		player.mo.state = S_PLAY_DROPDASH
		return true
	end	
end)

addHook("ShieldSpecial", function(player)
	if (player.mo.skin == dropskin)
	and (player.powers[pw_shield] & (SH_PITY|SH_FORCE|SH_WHIRLWIND|SH_ATTRACT|SH_THUNDERCOIN|SH_BUBBLEWRAP|SH_FLAMEAURA|SH_ELEMENTAL|SH_ARMAGEDDON))
	and (player.cmd.buttons & BT_USE)
	and not (player.playerstate == PST_DEAD)
		player.dropcharging = true
		S_StartSound(player.mo, sfx_drpdsh)
		player.mo.state = S_PLAY_DROPDASH
	end	
end)

addHook("PlayerThink", function(player)
	if player.dropcharging and not (player.cmd.buttons & BT_SPIN)
		player.dropcharging = false
		player.mo.state = S_PLAY_JUMP
	end	
end)


addHook("PlayerThink", function(player)
	if (player.mo.skin == dropskin)
		if player.dropcharging
			and (P_IsObjectOnGround(player.mo) or (player.mo.eflags & MFE_JUSTHITFLOOR))
			and not P_CheckDeathPitCollide(player.mo, true)
				S_StartSound(player.mo, sfx_zoom)
				player.mo.state = S_PLAY_ROLL
				player.dropcharging = false
				player.pflags = $|PF_SPINNING
				P_InstaThrust(player.mo, player.mo.angle, 8*FRACUNIT+player.speed)
				for i = 0, 6
				local mdust = P_SpawnMobj(player.mo.x, player.mo.y, player.mo.z, MT_DUST)
				if mdust and mdust.valid
				P_InstaThrust(mdust, i*7*ANG30, -5*FRACUNIT)
			end
		end
    end
end	
end)

addHook("PlayerThink", function(p)
	if (p.mo.skin == dropskin)
		if p.dropcharging
		and (p.powers[pw_justsprung] or p.mo.eflags & MFE_SPRUNG)
		or p.dropcharging
		and P_PlayerInPain(p)
		or p.dropcharging
		and (p.playerstate == PST_DEAD or P_CheckDeathPitCollide(p.mo, true))
			p.dropcharging = false
		end	
	end
end)

addHook("PlayerThink", function(p)
	if (p.mo.skin == dropskin)
	and (p.pflags & PF_JUMPED)
		p.pflags = $ & ~PF_SPINNING
	end
end)